(function (window, $, document, undefined)
{
    // Declare the ARM namespace object(s)
    window.arm = {};

})(window, jQuery, document);
(function (window, $, document, undefined)
{
    /*
     * Find all sidebar elements on the page, and rearrange the sections so that they are properly aligned with
     * the sidebar.
     */
    $(document).ready(function ()
    {
        // Find all elements with the .sidebar class
        $(".sidebar").each(function ()
        {
            var sidebar = $(this);
            var start = sidebar.data("section-start");

            // First see if there is already a sidebar container before the section
            var sidebarContainer = null;
            var previousEl = $(".section" + start).prev();
            if(previousEl.hasClass("sidebar-container")) {
                sidebarContainer = previousEl;
            }

            if(!sidebarContainer) {
                // Create the html for the new container
                var html = '<div class="sidebar-container"> </div>';

                // Add the container before the start section
                $(".section" + start).before(html);
                sidebarContainer = $(".section" + start).prev();
            }

            // Move the sidebar to the sidebar container
            sidebarContainer.append(sidebar);
        });

    });

})(window, jQuery, document);
(function (window, $, document, undefined)
{
    /*
     * Add hover/click listeners to primary nav
     */
    $(document).ready(function ()
    {
        $('nav.primary ul.navbar li.dropdown').hover(function() {
            $(this).find('.dropdown-menu').stop(true, true).delay(100).fadeIn(300);
            $(this).find('span').addClass("hov-active");
        }, function() {
            $(this).find('.dropdown-menu').stop(true, true).delay(100).fadeOut(300);
            $(this).find('span').removeClass("hov-active");
        });

        $('nav.primary ul.navbar li.dropdown a').on('click', function(e) {
            e.stopPropagation();

            // get the href from the anchor and navigate to it
            var $a = $(this);
            var href = $a.attr('href');
            window.location.href = href;
        });

        // Search Box
        var search = function(event) {
            var enterKey = 13;

            if(event.type === 'mousedown' || event.keyCode === enterKey) {
                event.preventDefault;
                var query = $('#search-arm-input').val();
                var url = encodeURI('https://www.arm.gov/search?q=' + query).replace("+", "%2B");

                window.location.replace(url);
            }
        };
        $('#search-arm-input').on('keydown', search);
        $('#search-arm-button').on('mousedown', search);


    });

})(window, jQuery, document);
(function (window, $, document, undefined)
{
    /*
     * Dynamically compute the proper width of the title vs. intro text box so there is variable padding
     * depending upon how long the title is.
     */
    $(document).ready(function ()
    {
        // Calculate the proper width of the title relative to the description
        // If description doesn't exist, then we can ignore
        var $description = $(".intro .description");
        if ($description.length > 0) {
            var $title = $(".title-box .title");
            var $h1 = $(".title-box .title h1");
            var titleWidth = $h1.width();

            if(titleWidth > 500) {
                // get rid of the nowrap as we will have to wrap
                $h1.css("white-space", "normal");

                // change the width of the title element
                $title.css("width", "500px");
            }
        }
    });

})(window, jQuery, document);
(function (window, document, $, B, H, undefined)
{
    arm.openMessageDialog = function(title, message) {
        $("#modal-message-dialog .modal-title").text(title);
        $("#modal-message-dialog .modal-body").text(message);
        $("#modal-message-dialog").modal('show');
    };

    arm.openContactUsForm = function(type){
        var title = ""; var options = "";
        if(type == 'data-questions'){
            title = 'Contact ARM With Your Data Question';
            options = '<option value="" disabled selected hidden>I need help with...</option>' +
                '<option value="ARM - Data Discovery and Access">Finding ARM Data</option> ' +
                '<option value="ARM - Data Quality Office">Data Quality Issues</option> ' +
                '<option value="ARM - General Help Desk">Other</option>';

        } else {
            title = 'Ask Us';
            options = '<option value="" disabled selected hidden>I need help with...</option>' +
                '<option value="ARM - Campaigns and Facilities Access">Campaigns and Accessing ARM Facilities</option> ' +
                '<option value="ARM - Data Discovery and Access">Finding ARM Data</option> ' +
                '<option value="ARM - Instruments and Data Products">Instruments and VAPs</option> ' +
                '<option value="ARM - Data Quality Office">Data Quality Issues</option> ' +
                '<option value="ARM - Website">ARM Website</option> ' +
                '<option value="ARM - General Help Desk">Other</option>';
        }
        $('#contact-us-modal .modal-title').text(title);
        $('#contact-us-modal #contact-us-category').html(options);
        $('#contact-us-modal').modal('show');
    };

    arm.closeContactUsForm = function () {
        $("#contact-us-modal").modal('hide');
        $('#contact-us-form')[0].reset();
        grecaptcha.reset();
        $("#btn-contact-us-send").prop("disabled", true);
    };

    arm.openImageModal = function(object) {
        $("#modal-message-dialog .modal-title").empty();
        $("#modal-message-dialog .modal-footer").empty();
        $("#modal-message-dialog .modal-body").html(object);
        $("#modal-message-dialog").modal('show');
    };

    /**
     * Called when reCaptcha is successful to enable the send button.  Declared via
     * the data-callback attribute on the recaptcha element.  Apparently having the
     * arm namespace in the function name prevents it from being called correctly, so
     * I'm adding it to the global scope instead.
     */
    window.enableContactUsButton = function() {
        $("#btn-contact-us-send").prop("disabled", false);
    };

    arm.submitContactUsForm = function() {

        // disable send button
        $("#btn-contact-us-send").prop("disabled", true);

        var data = $("#contact-us-form").serialize();

        $.ajax({
            type: "POST",
            url: "/action/contact-us",
            data: data

        }).done(function(data){
            arm.closeContactUsForm();
            arm.openMessageDialog("Thank you!", "Your message has been successfully sent. We will contact you very soon!");

        }).fail(function(msg) {
            arm.openMessageDialog("Alert", "Form submission failed: " + msg);
            $("#btn-contact-us-send").prop("disabled", false); // re-enable the send button
            grecaptcha.reset(); // reset the captcha

        })

    };

    arm.ModalView = B.View.extend({

        initialize: function(opts){
            $('body').append(opts.template(this.model?this.model.toJSON():undefined));
            this.setElement($('body > .modal:last-child').last());
        },

        render: function(){
            this._onShow   = this.onShow.bind(this);
            this._onShown  = this.onShown.bind(this);
            this._onHide   = this.onHide.bind(this);
            this._onHidden = this.onHidden.bind(this);
            this.$el
                .modal('show')
                .on('show.bs.modal',   this._onShow)
                .on('shown.bs.modal',  this._onShown)
                .on('hide.bs.modal',   this._onHide)
                .on('hidden.bs.modal', this._onHidden);
        },

        done: function(){
            this.$el.modal('hide');
        },

        onShow: function(e){
        },

        onShown: function(e){
        },

        onHide: function(e){
        },

        onHidden: function(e){
        }
    });

    $("a[href='#contact:data']").click(function(e){
        e.preventDefault();
        arm.openContactUsForm('data-questions');
        return false;
    });
    $("a[href='#contact']").click(function(e){
        e.preventDefault();
        arm.openContactUsForm();
        return false;
    });

})(window, document, jQuery, Backbone);

//rnadom short lines of needed js

//needed so that short sections with larger images have overflow auto
//but normal sections don't have overflow auto so that they wrap correctly with sidebars
$('.section').has('figure').css("overflow","auto");

//some figures have links around images and this is going to mess with that, putting it on to-do wiki list
$('.content-area.highlight figure').on('click',function(){
    var figure = $(this).clone();
    arm.openImageModal(figure);
});
